Index: /java/main/src/main/java/com/framsticks/params/ParamCandidate.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/ParamCandidate.java	(revision 86)
@@ -0,0 +1,279 @@
+package com.framsticks.params;
+
+import java.lang.reflect.AnnotatedElement;
+import java.lang.reflect.Array;
+import java.lang.reflect.Field;
+import java.lang.reflect.GenericArrayType;
+import java.lang.reflect.Member;
+import java.lang.reflect.Method;
+import java.lang.reflect.Modifier;
+import java.lang.reflect.ParameterizedType;
+import java.lang.reflect.Type;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.Map;
+
+import com.framsticks.params.annotations.ParamAnnotation;
+
+public class ParamCandidate {
+
+	public class OneTime<T> {
+		protected final String name;
+		T value;
+
+		/**
+		 * @param name
+		 */
+		public OneTime(String name) {
+			this.name = name;
+		}
+
+		final void set(T value) {
+			if (this.value == null) {
+				this.value = value;
+				return;
+			}
+			if (!this.value.equals(value)) {
+				throw new ConstructionException().msg("already set")
+					.arg("name", name)
+					.arg("in", ParamCandidate.this)
+					.arg("already", this.value)
+					.arg("now", value);
+			}
+		}
+
+		public final T get() {
+			return value;
+		}
+
+		public final boolean has() {
+			return value != null;
+		}
+
+		@Override
+		public String toString() {
+			return value == null ? "<null>" : value.toString();
+		}
+
+
+	}
+
+	protected final String id;
+	protected final OneTime<String> name = new OneTime<>("name");
+	protected final OneTime<Type> type = new OneTime<>("type");
+	protected final OneTime<Field> field = new OneTime<>("field");
+	protected final OneTime<Method> setter = new OneTime<>("setter");
+	protected final OneTime<Method> getter = new OneTime<>("getter");
+
+	/**
+	 * @param id
+	 */
+	public ParamCandidate(String id) {
+		this.id = id;
+	}
+
+	/**
+	 * @return the id
+	 */
+	public String getId() {
+		return id;
+	}
+
+	/**
+	 * @return the name
+	 */
+	public String getName() {
+		return name.get();
+	}
+
+	/**
+	 * @return the type
+	 */
+	public Type getType() {
+		return type.get();
+	}
+
+	public Class<?> getRawType() {
+		return getRawClass(type.get());
+	}
+
+	void setType(Type type) {
+		this.type.set(type);
+	}
+
+
+	/**
+	 * @return the field
+	 */
+	public Field getField() {
+		return field.get();
+	}
+
+	/**
+	 * @return the setter
+	 */
+	public Method getSetter() {
+		return setter.get();
+	}
+
+	/**
+	 * @return the getter
+	 */
+	public Method getGetter() {
+		return getter.get();
+	}
+
+	void validate() throws ConstructionException {
+		try {
+			if (isPublic(field)) {
+				if (getter.has()) {
+					throw new ConstructionException().msg("getter and public field coexist");
+				}
+				return;
+			}
+			if (field.has()) {
+				if (setter.has()) {
+					throw new ConstructionException().msg("setter and field coexist");
+				}
+			}
+
+			if (getter.get() == null) {
+				throw new ConstructionException().msg("missing getter");
+			}
+		} catch (ConstructionException e) {
+			throw e.arg("in", this);
+		}
+	}
+
+	boolean isFinal() {
+		if (Collection.class.isAssignableFrom(getRawType())) {
+			return false;
+		}
+		if (setter.has()) {
+			return false;
+		}
+		if (field.has()) {
+			return Modifier.isFinal(field.get().getModifiers());
+		}
+		return true;
+	}
+
+	boolean isReadOnly() {
+		if (Collection.class.isAssignableFrom(getRawType())) {
+			return false;
+		}
+		if (isPublic(setter)) {
+			return false;
+		}
+		if (isPublic(field)) {
+			return Modifier.isFinal(field.get().getModifiers());
+		}
+		return true;
+	}
+
+	void add(Member member, String name) {
+		this.name.set(name);
+		if (member instanceof Field) {
+			this.field.set((Field) member);
+			setType(field.get().getGenericType());
+			return;
+		}
+		if (member instanceof Method) {
+			Method m = (Method) member;
+			Type[] ps = m.getGenericParameterTypes();
+			if (ps.length == 0) {
+				getter.set(m);
+				setType(m.getGenericReturnType());
+				return;
+			}
+			if (ps.length == 1) {
+				setter.set(m);
+				setType(ps[0]);
+				return;
+			}
+			throw new ConstructionException().msg("invalid number of arguments").arg("method", m).arg("in", this);
+		}
+		throw new ConstructionException().msg("invalid kind of member").arg("member", member).arg("in", this);
+	}
+
+	public boolean isPrimitive() {
+		return getRawType().isPrimitive();
+	}
+
+	public int getFlags() {
+		int f = 0;
+		if (isReadOnly()) {
+			f |= Flags.READONLY;
+		}
+		return f;
+	}
+
+	@Override
+	public String toString() {
+		return id;
+	}
+
+	public static boolean isPublic(Member member) {
+		return Modifier.isPublic(member.getModifiers());
+	}
+
+	public static boolean isPublic(OneTime<? extends Member> v) {
+		return v.has() ? isPublic(v.get()) : false;
+	}
+
+	public static <M extends Member & AnnotatedElement> void filterParamsCandidates(Map<String, ParamCandidate> params, M[] members) {
+		for (M m : members) {
+			ParamAnnotation pa = m.getAnnotation(ParamAnnotation.class);
+			if (pa == null) {
+				continue;
+			}
+			// if (!isPublic(m)) {
+			// 	throw new ConstructionException().msg("field is not public").arg("field", m);
+			// }
+			String id = FramsClassBuilder.getId(pa, m);
+			ParamCandidate pc = null;
+			if (params.containsKey(id)) {
+				pc = params.get(id);
+			} else {
+				pc = new ParamCandidate(id);
+				params.put(id, pc);
+			}
+			pc.add(m, FramsClassBuilder.getName(pa, m));
+
+		}
+	}
+
+	public static Map<String, ParamCandidate> getAllCandidates(Class<?> javaClass) throws ConstructionException {
+		Map<String, ParamCandidate> candidates = new HashMap<>();
+
+		while (javaClass != null) {
+			filterParamsCandidates(candidates, javaClass.getDeclaredFields());
+			filterParamsCandidates(candidates, javaClass.getDeclaredMethods());
+
+			javaClass = javaClass.getSuperclass();
+		}
+
+		for (ParamCandidate pc : candidates.values()) {
+			pc.validate();
+		}
+
+		return candidates;
+	}
+
+	public static Class<?> getRawClass(final Type type) {
+		if (Class.class.isInstance(type)) {
+			return Class.class.cast(type);
+		}
+		if (ParameterizedType.class.isInstance(type)) {
+			final ParameterizedType parameterizedType = ParameterizedType.class.cast(type);
+			return getRawClass(parameterizedType.getRawType());
+		} else if (GenericArrayType.class.isInstance(type)) {
+			GenericArrayType genericArrayType = GenericArrayType.class.cast(type);
+			Class<?> c = getRawClass(genericArrayType.getGenericComponentType());
+			return Array.newInstance(c, 0).getClass();
+		} else {
+			return null;
+		}
+	}
+
+};
Index: /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/ReflectionAccess.java	(revision 86)
@@ -3,10 +3,13 @@
 import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
-import java.lang.reflect.Modifier;
+import java.lang.reflect.Method;
+import java.util.HashMap;
+import java.util.Map;
 
 import org.apache.log4j.Logger;
 
-import com.framsticks.util.lang.Containers;
-
+import com.framsticks.util.FramsticksException;
+
+import static com.framsticks.util.lang.Containers.*;
 
 /**
@@ -19,48 +22,138 @@
  */
 public class ReflectionAccess extends SimpleAbstractAccess {
-	private final static Logger log = Logger.getLogger(ReflectionAccess.class.getName());
+	private final static Logger log = Logger.getLogger(ReflectionAccess.class
+			.getName());
 
 	protected final Class<?> reflectedClass;
 	private Object object;
 
-	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) {
+
+	protected interface ReflectedSetter {
+		public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	protected interface ReflectedGetter {
+		public abstract <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException;
+	}
+
+	protected static class ReflectedValueParam {
+		public ReflectedSetter setter;
+		public ReflectedGetter getter;
+	}
+
+	protected final Map<ValueParam, ReflectedValueParam> reflectedValueParams = new HashMap<>();
+
+	public ReflectionAccess(Class<?> reflectedClass) throws ConstructionException {
+		this(reflectedClass, FramsClassBuilder.buildForClass(reflectedClass));
+	}
+
+	public static boolean typeMatch(Class<?> a, Class<?> b) {
+		assert !b.isPrimitive();
+		if (!a.isPrimitive()) {
+			return a.equals(b);
+		}
+
+		if (a.equals(int.class)) {
+			return b.equals(Integer.class);
+		}
+		if (a.equals(double.class)) {
+			return b.equals(Double.class);
+		}
+		if (a.equals(boolean.class)) {
+			return b.equals(Boolean.class);
+		}
+		assert false;
+		return false;
+	}
+
+	public ReflectionAccess(Class<?> reflectedClass, FramsClass framsClass) throws ConstructionException {
 		this.reflectedClass = reflectedClass;
 		setFramsClass(framsClass);
-	}
-
-	private static String accessorName(boolean get, String id) {
-		return (get ? "get"  : "set") + id.substring(0, 1).toUpperCase() + id.substring(1);
-	}
+
+		Map<String, ParamCandidate> candidates = ParamCandidate.getAllCandidates(reflectedClass);
+
+		try {
+			for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+				if (!candidates.containsKey(vp.getId())) {
+					throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
+				}
+				ParamCandidate pc = candidates.get(vp.getId());
+				if (pc.isReadOnly() && !vp.hasFlag(Flags.READONLY)) {
+					throw new ConstructionException().msg("readonly state conflict").arg("param", vp);
+				}
+				if (!typeMatch(pc.getRawType(), vp.getStorageType())) {
+					throw new ConstructionException().msg("types mismatch for param").arg("param", vp).arg("candidate", pc.getType()).arg("storage", vp.getStorageType());
+				}
+
+				ReflectedValueParam rvp = new ReflectedValueParam();
+				reflectedValueParams.put(vp, rvp);
+				final boolean primitive = pc.isPrimitive();
+				if (pc.getField() != null) {
+					final Field f = pc.getField();
+					rvp.getter = new ReflectedGetter() {
+						@Override
+						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException {
+							return type.cast(f.get(object));
+						}
+					};
+					if (!pc.isFinal()) {
+						rvp.setter = new ReflectedSetter() {
+							@Override
+							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException {
+								if (value == null && primitive) {
+									throw new FramsticksException().msg("setting null to primitive value");
+								}
+								f.set(object, value);
+							}
+						};
+					}
+				} else {
+					final Method g = pc.getGetter();
+
+					rvp.getter = new ReflectedGetter() {
+						@Override
+						public <T> T get(Object object, Class<T> type) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+							return type.cast(g.invoke(object));
+						}
+					};
+
+					if (!pc.isFinal()) {
+						final Method s = pc.getSetter();
+						rvp.setter = new ReflectedSetter() {
+							@Override
+							public <T> void set(Object object, T value) throws IllegalArgumentException, IllegalAccessException, InvocationTargetException {
+								if (value == null && primitive) {
+									throw new FramsticksException().msg("setting null to primitive value");
+								}
+								s.invoke(object, value);
+							}
+						};
+					}
+				}
+			}
+		} catch (ConstructionException e) {
+			throw e.arg("java class", reflectedClass).arg("framsClass", framsClass);
+		}
+	}
+
+	// private static String accessorName(boolean get, String id) {
+	//	return (get ? "get" : "set") + id.substring(0, 1).toUpperCase() + id.substring(1);
+	// }
 
 	@Override
 	public <T> T get(ValueParam param, Class<T> type) {
-		if (object == null) {
-			return null;
-		}
-		try {
-			//TODO: use internal id, if present
-			String id = param.getId();
+		try {
 			try {
-				return type.cast(reflectedClass.getField(id).get(object));
-			} catch (NoSuchFieldException ignored) {
-			}
-			try {
-				return type.cast(reflectedClass.getMethod(accessorName(true, id)).invoke(object));
-			} catch (NoSuchMethodException | InvocationTargetException ex) {
-				//e.printStackTrace();
-			}
-			try {
-				return type.cast(reflectedClass.getMethod(id).invoke(object));
-			} catch (NoSuchMethodException | InvocationTargetException ex) {
-				//e.printStackTrace();
-			}
-
-		} catch (IllegalAccessException e) {
-			log.warn("illegal access error occurred while trying to access returnedObject");
-			e.printStackTrace();
-		} catch (ClassCastException ignored) {
-
-		}
-		return null;
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+
+				return reflectedValueParams.get(param).getter.get(object, type);
+			} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
+				throw new FramsticksException().msg("failed to get").cause(e);
+			}
+		} catch (FramsticksException e) {
+			throw e.arg("param", param).arg("type", type).arg("access", this);
+		}
 	}
 
@@ -71,31 +164,19 @@
 
 	private <T> void setValue(ValueParam param, T value) {
-		if (object == null) {
-			return;
-		}
-		try {
-			String id = param.getId();
+		try {
 			try {
-				Field f = reflectedClass.getField(id);
-				Class<?> t = f.getType();
-				if (Modifier.isFinal(f.getModifiers())) {
-					return;
-				}
-				if (value != null || (!t.isPrimitive())) {
-					f.set(object, value);
-				}
-				return;
-			} catch (NoSuchFieldException ignored) {
-			}
-			try {
-				reflectedClass.getMethod(accessorName(false, id), new Class[]{param.getStorageType()}).invoke(object, value);
-			} catch (InvocationTargetException | NoSuchMethodException ignored) {
-			}
-			try {
-				reflectedClass.getMethod(id, new Class[]{param.getStorageType()}).invoke(object, value);
-			} catch (InvocationTargetException | NoSuchMethodException ignored) {
-			}
-		} catch (Exception ex) {
-			ex.printStackTrace();
+				if (object == null) {
+					throw new FramsticksException().msg("no object set");
+				}
+				ReflectedSetter s = reflectedValueParams.get(param).setter;
+				if (s == null) {
+					throw new FramsticksException().msg("trying to set final");
+				}
+				s.set(object, value);
+			} catch (IllegalArgumentException | IllegalAccessException | InvocationTargetException e) {
+				throw new FramsticksException().msg("failed to set").cause(e);
+			}
+		} catch (FramsticksException e) {
+			throw e.arg("param", param).arg("value", value).arg("access", this);
 		}
 	}
@@ -114,5 +195,5 @@
 
 		try {
-			for (ValueParam p : Containers.filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+			for (ValueParam p : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
 				setValue(p, p.getDef(Object.class));
 			}
@@ -159,5 +240,5 @@
 
 	@Override
-	public ReflectionAccess cloneAccess() {
+	public ReflectionAccess cloneAccess() throws ConstructionException {
 		return new ReflectionAccess(reflectedClass, framsClass);
 	}
@@ -173,3 +254,15 @@
 		return null;
 	}
+
+	@Override
+	public String toString() {
+		StringBuilder b = new StringBuilder();
+		b.append(framsClass);
+		if (object != null) {
+			b.append("(").append(object).append(")");
+		}
+		return b.toString();
+	}
+
 }
+
Index: /java/main/src/main/java/com/framsticks/params/Registry.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/Registry.java	(revision 86)
@@ -2,4 +2,6 @@
 
 import org.apache.log4j.Logger;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
 
 import java.util.HashMap;
@@ -35,5 +37,17 @@
 	}
 
-	public AccessInterface createAccess(String name, FramsClass framsClass) {
+	public Registry register(Class<?> reflectedClass) {
+		FramsClassAnnotation a = reflectedClass.getAnnotation(FramsClassAnnotation.class);
+		if (a == null) {
+			log.error("class is not annotated: " + reflectedClass);
+			return this;
+		}
+
+		registerReflectedClass(FramsClassBuilder.getName(a, reflectedClass), FramsClassBuilder.getId(a, reflectedClass), reflectedClass);
+
+		return this;
+	}
+
+	public AccessInterface createAccess(String name, FramsClass framsClass) throws ConstructionException {
 		if (reflectedClasses.containsKey(name)) {
 			return new ReflectionAccess(reflectedClasses.get(name), framsClass);
@@ -66,15 +80,15 @@
 
 	public static AccessInterface wrapAccessWithListIfNeeded(CompositeParam param, AccessInterface access) {
-        if (access == null) {
+		if (access == null) {
 			return null;
 		}
-        return param.prepareAccessInterface(access);
+		return param.prepareAccessInterface(access);
 	}
 
-    public AccessInterface prepareAccess(CompositeParam param) {
-        return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
-    }
+	public AccessInterface prepareAccess(CompositeParam param) throws ConstructionException {
+		return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
+	}
 
-	public AccessInterface createAccess(String name) {
+	public AccessInterface createAccess(String name) throws ConstructionException {
 		if (name == null) {
 			return null;
Index: /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 86)
@@ -65,10 +65,10 @@
 	@Override
 	public Param getParam(int i) {
-		return framsClass.getParamEntry(i, Param.class);
+		return framsClass.getParam(i);
 	}
 
 	@Override
 	public Param getParam(String id) {
-		return framsClass.getParamEntry(id, Param.class);
+		return framsClass.getParam(id);
 	}
 
@@ -80,28 +80,20 @@
 	@Override
 	public <T> T get(int i, Class<T> type) {
-		Param p = getParam(i);
-		assert p instanceof ValueParam;
-		return get((ValueParam) p, type);
+		return get(framsClass.getParamEntry(i, ValueParam.class), type);
 	}
 
 	@Override
 	public <T> T get(String id, Class<T> type) {
-		Param p = getParam(id);
-		assert p instanceof ValueParam;
-		return get((ValueParam) p, type);
+		return get(framsClass.getParamEntry(id, ValueParam.class), type);
+	}
+
+	@Override
+	public <T> int set(int i, T value) {
+		return set(framsClass.getParamEntry(i, ValueParam.class), value);
 	}
 
 	@Override
 	public <T> int set(String id, T value) {
-		Param p = getParam(id);
-		assert p instanceof ValueParam;
-		return set((ValueParam) p, value);
-	}
-
-	@Override
-	public <T> int set(int i, T value) {
-		Param p = getParam(i);
-		assert p instanceof ValueParam;
-		return set((ValueParam) p, value);
+		return set(framsClass.getParamEntry(id, ValueParam.class), value);
 	}
 
@@ -115,5 +107,5 @@
 			ReassignResult<?> result = param.reassign(value, oldValue);
 			Object casted = result.getValue();
-			if (casted != oldValue) {
+			if (!casted.equals(oldValue)) {
 				internalSet(param, casted);
 			}
Index: /java/main/src/main/java/com/framsticks/params/SimpleSource.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SimpleSource.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/SimpleSource.java	(revision 86)
@@ -6,10 +6,10 @@
 public class SimpleSource implements SourceInterface {
 
-	final String content;
+	String content;
 	int cursor;
 
 	public SimpleSource(String content) {
 		this.content = content;
-        cursor = 0;
+		cursor = 0;
 	}
 
@@ -21,4 +21,5 @@
 	@Override
 	public String readLine() {
+		assert !isClosed();
 		if (cursor >= content.length()) {
 			return null;
@@ -45,5 +46,12 @@
 	@Override
 	public void close() {
+		content = null;
+	}
 
+	//TODO no magic numbers
+	@Override
+	public boolean isClosed() {
+		return content != null;
 	}
+
 }
Index: /java/main/src/main/java/com/framsticks/params/SourceInterface.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/SourceInterface.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/params/SourceInterface.java	(revision 86)
@@ -7,3 +7,4 @@
 	SourceInterface openInclude(String include);
 	void close();
+	boolean isClosed();
 }
Index: /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/annotations/FramsClassAnnotation.java	(revision 86)
@@ -0,0 +1,13 @@
+package com.framsticks.params.annotations;
+
+import java.lang.annotation.ElementType;
+import java.lang.annotation.Retention;
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Target;
+
+@Retention(RetentionPolicy.RUNTIME)
+@Target(ElementType.TYPE)
+public @interface FramsClassAnnotation {
+	String name() default "";
+	String id() default "";
+}
Index: /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java
===================================================================
--- /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 86)
+++ /java/main/src/main/java/com/framsticks/params/annotations/ParamAnnotation.java	(revision 86)
@@ -0,0 +1,14 @@
+package com.framsticks.params.annotations;
+
+import java.lang.annotation.ElementType;
+import java.lang.annotation.Retention;
+import java.lang.annotation.RetentionPolicy;
+import java.lang.annotation.Target;
+
+@Retention(RetentionPolicy.RUNTIME)
+@Target({ElementType.FIELD, ElementType.METHOD})
+public @interface ParamAnnotation {
+	String name() default "";
+	String id() default "";
+}
+
Index: /java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 86)
@@ -17,5 +17,4 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.util.lang.Containers;
-import com.framsticks.util.lang.Exceptions;
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
@@ -119,5 +118,5 @@
 
 	private static void warn(int lineNumber, String message, Exception e) {
-		log.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e + "\n" + Exceptions.printStackTrace(e));
+		log.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e);
 	}
 
Index: /java/main/src/main/java/com/framsticks/parsers/FileSource.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/parsers/FileSource.java	(revision 86)
@@ -9,8 +9,8 @@
 public class FileSource implements SourceInterface {
 
-	private final BufferedReader reader;
+	private BufferedReader reader;
 	private final String filename;
 
-	protected FileSource(InputStream stream, String filename) {
+	public FileSource(InputStream stream, String filename) {
 		this.filename = filename;
 		this.reader = new BufferedReader(new InputStreamReader(stream, Encoding.getFramsticksCharset()));
@@ -28,4 +28,5 @@
 	public String readLine()
 	{
+		assert !isClosed();
 		try
 		{
@@ -80,4 +81,10 @@
 
 		}
+		reader = null;
+	}
+
+	@Override
+	public boolean isClosed() {
+		return reader == null;
 	}
 
Index: /java/main/src/main/java/com/framsticks/parsers/Loaders.java
===================================================================
--- /java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 85)
+++ /java/main/src/main/java/com/framsticks/parsers/Loaders.java	(revision 86)
@@ -2,5 +2,5 @@
 
 import com.framsticks.params.*;
-import org.apache.log4j.Logger;
+// import org.apache.log4j.Logger;
 
 /**
@@ -9,7 +9,7 @@
 public class Loaders {
 
-	private static final Logger log = Logger.getLogger(Loaders.class.getName());
+	// private static final Logger log = Logger.getLogger(Loaders.class.getName());
 
-	public static FramsClass loadFramsClass(SourceInterface source) {
+	public static FramsClass loadFramsClass(SourceInterface source) throws ConstructionException {
 		MultiParamLoader loader = new MultiParamLoader();
 		loader.setNewSource(source);
@@ -17,6 +17,6 @@
 		FramsClass result = new FramsClass();
 
-		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class, FramsClass.getFramsClass());
-		AccessInterface paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, ParamBuilder.getFramsClass());
+		AccessInterface framsClassAccess = new ReflectionAccess(FramsClass.class, FramsClassBuilder.buildForClass(FramsClass.class));
+		AccessInterface paramBuilderAccess = new ReflectionAccess(ParamBuilder.class, FramsClassBuilder.buildForClass(ParamBuilder.class));
 		framsClassAccess.select(result);
 		loader.addAccessInterface(framsClassAccess);
@@ -41,10 +41,6 @@
 			return result;
 		} catch (Exception e) {
-			log.error("an error occurred while loading class description: " + e + " before " + source.readLine());
-			e.printStackTrace();
+			throw new ConstructionException().msg("an error occurred while loading class description").arg("before", loader.getCurrentLine()).cause(e);
 		}
-		return null;
-
-
 	}
 }
